package com.huimv.guowei.admin.controller;


import com.alibaba.druid.util.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnvDevice;
import com.huimv.guowei.admin.service.IEnvDeviceService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/env-device")
@CrossOrigin
public class EnvDeviceController {
    @Resource
    private IEnvDeviceService envDeviceService;
    @PostMapping("/listDevice")
    public Result listDevice(@RequestBody Map<String ,String> paramsMap){
        String deviceType = paramsMap.get("deviceType");
        String farmId = paramsMap.get("farmId");
        String pageNo = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        Page<EnvDevice> page = new Page(Integer.parseInt(pageNo),Integer.parseInt(pageSize));

        return new Result(ResultCode.SUCCESS,envDeviceService.page(page, new QueryWrapper<EnvDevice>()
                        .eq(!StringUtils.isEmpty(deviceType),"device_type",deviceType)
                        .eq("farm_id",farmId)));
    }


}
